﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SyncfusionMvcApplication24;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Collections;
using System.Reflection;
using MVCSampleBrowser.Models;
namespace SyncfusionMvcApplication24.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
       public static List<Employee> employee = new List<Employee>(); 
        public ActionResult GridFeatures()
        {
            var DataSource1 = new NorthwindDataContext().OrdersViews.Take(100).ToList();
            ViewBag.dataSource1 = DataSource1;
            employee.Add(new Employee(1, "Michael"));
            employee.Add(new Employee(2, "Anne"));
            employee.Add(new Employee(3, "Janet"));
            employee.Add(new Employee(4, "Andrew"));
            employee.Add(new Employee(5, "Margaret"));
            employee.Add(new Employee(6, "Nancy"));
            employee.Add(new Employee(7, "Robert"));
            employee.Add(new Employee(8, "Laura"));
            employee.Add(new Employee(9, "Steven"));
            employee.Add(new Employee(10, "James"));
            employee.Add(new Employee(11, "Smith"));
            employee.Add(new Employee(12, "Jhonson"));
            employee.Add(new Employee(13, "George"));
            ViewBag.dataSource2 = employee;
            return View();
        }
        public ActionResult CellEditUpdate(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public ActionResult CellEditInsert(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            return Json(value, JsonRequestBehavior.AllowGet);
        }

        public ActionResult CellEditDelete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var DataSource = OrderRepository.GetAllRecords().Take(100).ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            obj.Columns[2].DataSource = employee;
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");
        }
        public void ExportToWord(string GridModel)
        {
            WordExport exp = new WordExport();
            var DataSource = OrderRepository.GetAllRecords().ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            obj.Columns[2].DataSource = employee;
            exp.Export(obj, DataSource, "Export.docx", false, false, "flat-saffron");
        }
        public void ExportToPdf(string GridModel)
        {
            PdfExport exp = new PdfExport();
            var DataSource = OrderRepository.GetAllRecords().ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            obj.Columns[2].DataSource = employee;
            exp.Export(obj, DataSource, "Export.pdf", false, false, "flat-saffron");
        }
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }
        public class Employee
        {
            public Employee()
            {

            }
            public Employee(int EmployeeId, string FirstName)
            {
                this.EmployeeID = EmployeeId;
                this.FirstName = FirstName;
            }
            public int EmployeeID { get; set; }
            public string FirstName { get; set; }
        }
    }
}
